//	ATtiny2313
//	Videoo ubN
//
//	ATtiny2313̓q[Yrbg20MHz
//	ubh{[hɂăeXg
//
//	2008/11/19	v1.00		Program:    1838 bytes (89.7% Full)
//								Data:         89 bytes (69.5% Full)
//						WinAVR-20080610	œKIvVu-O2v
//
//	2008/11/21	v1.10	Program:    1472 bytes (71.9% Full)
//						Data:         82 bytes (64.1% Full)
//						WinAVR-20080610	œKIvVu-O2v
//						EsleeppɕύXB`̃uȂȂ
//						EregisterCŃvOTCYk
//						Edelay_loop()nop()ŋɕ`ʒu

/*	|[gΉ	[ATtiny2313]
	bit		7	6	5	4	3	2	1	0
	PORTB	-	-	-	-	-	-	swR	swL		XCb`
	PORTD	x	-	-	-	-	-	V2	V1		Video1-2
	
	[Video Output]
	H=5v, L=0v
	Video1(1.2k)	H		L		H		L
	Video2(470)	H		H		L		L
	Output			0.91v	0.69v	0.29v	0v
					White	Gray	Black	Sync
	
	Video1>--R[1.2k]--+
	Video2>--R[ 470]--+--<Output
	                  |
	                  R[75]
	                  |
	                 ///
*/

#define	F_CPU	20000000UL	//20MHz

#include	<avr/io.h>
#include	<avr/interrupt.h>
#include	<avr/sleep.h>
#include	<util/delay.h>


#define	ColorWHITE	0b00000011
#define	ColorGRAY	0b00000010
#define	ColorBLACK	0b00000001
#define	SIGNAL_SYNC	0b00000000

#define	SCRN_COLOR	ColorBLACK		//ʔwiF
#define	BAR_COLOR	ColorGRAY		//o[̐F
#define	BALL_COLOR	ColorWHITE		//{[̐F
//{[̐FizɃZbglƂāj
#define	BALL_COLOR_NUM	2		//0:ColorBLACK, 1:ColorGRAY, 2:ColorWHITE

//`Ɋւ鑖̐ݒ
#define	DRAW_LINE_TOP	(21 + 2)	//\JnCijB21ȏł邱Ɓi+n͉ʐ؂ɑΏ钲lj
#define	CELL_H			10			//P}X̍CƂ邩
//vCtB[h̍L	オ(0,0)
#define	FIELD_W			16		//16}XiςƍœKɂĕ`悪K^j
#define	FIELD_H			24		//c24}X
//ubNAo[A{[̈ʒuA傫ivCtB[h̃}ẌʒuŎw肷BPʂł͂Ȃj
#define	BLOCK_COLUMN	FIELD_W
#define	BLOCK_ROW		4		//obt@TCY (BLOCK_COLUMN * BLOCK_ROW)byte ƂȂ
#define	BLOCK_AREA_Y	3		//0ȏł邱
#define	BLOCK_AREA_H	BLOCK_ROW
#define	BAR_Y			((FIELD_H - 1) - 1)		//o[̉ɂPšԂ󂯂iڂ̍D݂Łj
#define	BAR_W			5
//{[Ao[̈ړ
#define	DIREC_UP		-1		//W
#define	DIREC_DOWN		1		//W
#define	DIREC_LEFT		-1		//W
#define	DIREC_RIGHT		1		//W
#define	DIREC_NEUTRAL	0		//WωȂî݊֌Wj
#define	MOVE_WAIT		(263 * 3)	//ړ҂iPtB[h̑̔{Ŏw肷jFQ[̃Xs[h


#define delay_loop		_delay_loop_1		//delay_basic.hŒ`ꂽ֐𒼐ڎw肷
#define nop()			asm volatile("nop"::)
#define videoOut(c)		{ PORTD = c; }
#define cellToLine(c)	(DRAW_LINE_TOP + (c) * CELL_H)	//vCtB[h̃}Xڂ𑖍ɕϊ


uint8_t		block[BLOCK_ROW][BLOCK_COLUMN];		//ubN̔z	FɑΉl0,1,2
uint8_t		bbPos[BLOCK_COLUMN] = {0};			//{[Ao[̈ʒui[zi֐̈Ƃėpj
register	volatile	int8_t		barX	asm("r2");		//o[̈ʒui}XڂŎwj
register	volatile	int8_t		ballX	asm("r3");		//{[̈ʒui}XڂŎwj
register	volatile	int8_t		ballY	asm("r4");		//{[̈ʒui}XڂŎwj
register	volatile	uint16_t	lineCount	asm("r6");	//̃JE^(16bitȂ̂r+1܂łgp)
register	volatile	uint8_t		fieldCount	asm("r5");	//PtB[hiPʕ`j̃JE^


enum	_ST		//is
{
	ST_READY,
	ST_PLAY,
	ST_CLEAR,
	ST_GAMEOVER
};


//vg^Cv錾
void	draw();
void	aryPaint(uint16_t *aryptr, uint8_t size);
void	init(int8_t *barDirecX, int8_t *ballDirecX, int8_t *ballDirecY, uint8_t *restCount);


//8bit^C}^JE^荞
ISR(TIMER0_COMPA_vect)
{
	if (++lineCount == 263)		//^tB[h̋ʂ͂ȂAPtB[ȟJԂŉʂ
	{
		lineCount = 1;
		fieldCount++;
	}
	
	if (lineCount < 4)			//1-3C
	{
		videoOut(SIGNAL_SYNC);
		_delay_us(2.3);			//2.3us
		videoOut(ColorBLACK);
	}
	else if (lineCount < 7)		//4-6C
	{
		videoOut(SIGNAL_SYNC);
		_delay_us(58.86);		//63.56-4.7=58.86us
		videoOut(ColorBLACK);
	}
	else if (lineCount < 10)	//7-9C
	{
		videoOut(SIGNAL_SYNC);
		_delay_us(2.3);			//2.3us
		videoOut(ColorBLACK);
	}
	else	//10Cȍ~iʂŌ̂21Cȍ~j
	{
		//uLO
		videoOut(ColorBLACK);
		_delay_us(1.5);			//1.5us
		videoOut(SIGNAL_SYNC);
		_delay_us(4.7);			//4.7us
		videoOut(ColorBLACK);
		_delay_us(4.7);			//4.7us
		
		//c63.56-(1.5+4.7+4.7)=53.47usʂŌ1C͈̔
		//̊荞ݔ܂łɕ`揈{f[^邱
	}
	
	draw();
}

int	main(void)
{
	int8_t		ballDirecX, ballDirecY, barDirecX;	//{[Ao[̕
	uint16_t	moveWait;		//`^C~O҂
	uint8_t		sw;				//XCb`
	uint8_t		restCount;		//cubNiPubNQJEgj
	uint8_t		state;			//is
	uint8_t		ballPainted;	//ubN̈Ƀ{[`Ƃ̃tOiƂ̔ɕKvj
	
	//|[gݒ
	DDRD	= 0b00000011;	//VideoMI/Os2
	PORTB	= 0b00000011;	//XCb`2
	
	//8bit^C}ݒ
	TCCR0A	= 0b00000010;	//CTC
	TCCR0B	= 0b00000010;	//JEg 20MHz8 = 0.4usԊu
	OCR0A	= 159;			//荞ݎ 63.56us / 0.4us = 158.9JEg
	TIMSK	= 0b00000001;	//8bit:rv荞
	
	lineCount = 0;
	fieldCount = 0;
	moveWait = MOVE_WAIT;
	state = ST_READY;
	ballPainted = 0;
	
	//vCJn̏
	init(&barDirecX, &ballDirecX, &ballDirecY, &restCount);
	
	set_sleep_mode(SLEEP_MODE_IDLE);	//X[v[hw
	sei();		//荞݋
	
	while (1)
	{
		//X[v[h˓i荞ݔŕAj
		sleep_mode();
		//ȉAȀ
		
		if (state != ST_PLAY)	//vC̕`̗ɗ͗}邽߁A܂vCۂŕ
		{
			//ST_READYDIɏ
			//ST_CLEAR, ST_GAMEOVERST_READY̕҂Ԃiʕ\ԂĵŁA
			//@ڂ̔zA`̗ɗ͗}Hv
			if (state == ST_READY)
			{
				sw = PINB;
				if (~sw & 0b00000011)	//ǂ炩̃{^
				{
					state = ST_PLAY;
				}
			}
			else	//ST_CLEAR, ST_GAMEOVER
			{
				if (fieldCount == 0x80)		//KȎԑ҂
				{
					init(&barDirecX, &ballDirecX, &ballDirecY, &restCount);
					state = ST_READY;
				}
			}
			continue;	//while(1)
		}
		//ȉ(state == ST_PLAY)
		
		//{[Ao[̈ړ^C~O҂
		if (0 < --moveWait) continue;	//while(1)
		moveWait = MOVE_WAIT;
		
		//L[͔iςȂLj^o[ړ
		barDirecX = DIREC_NEUTRAL;
		sw = PINB;
		if ((~sw & 0b00000001) && 0 < barX)		//XCb`uv
		{
			barX--;
			barDirecX = DIREC_LEFT;
		}
		if ((~sw & 0b00000010) && barX < FIELD_W - BAR_W)	//XCb`uEv
		{
			barX++;
			barDirecX = DIREC_RIGHT;
		}
		
		//OAubN̈Ƀ{[
		if (BLOCK_AREA_Y <= ballY && ballY < BLOCK_AREA_Y + BLOCK_AREA_H)
		{
			if (ballPainted)	//̔肪ȂƗLȃubNĂ܂ƂN
			{
				uint8_t		rr = ballY - BLOCK_AREA_Y;
				block[rr][ballX] = 0;
				ballPainted = 0;
			}
		}
		
		//{[ړF
		if (ballX == 0)		//vCtB[h̍[Ŕ
		{
			ballDirecX = DIREC_RIGHT;
		}
		else if (ballX == FIELD_W - 1)		//vCtB[h̉E[Ŕ
		{
			ballDirecX = DIREC_LEFT;
		}
		ballX += ballDirecX;
		
		//{[ړFc
		if (ballY == 0)		//vCtB[h̏[Ŕ
		{
			ballDirecY = DIREC_DOWN;
		}
		else if (ballY == BAR_Y - 1)	//o[Ƃ̓蔻
		{
			if (barX <= ballX && ballX < barX + BAR_W)	//o[ɓꍇ
			{
				ballDirecY = DIREC_UP;	//
				
				//{[̉̐ύX
				//bar_ball	||||
				//----------+--+--+--+
				//		|<<|||
				//|		||||
				//		|||>>|
				if (ballDirecX == DIREC_LEFT)
				{
					if (barDirecX == DIREC_LEFT && 0 < ballX) ballX--;	//o[łP}X点
					else if (barDirecX == DIREC_RIGHT) ballDirecX = DIREC_NEUTRAL;
				}
				else if (ballDirecX == DIREC_RIGHT)
				{
					if (barDirecX == DIREC_RIGHT && ballX < FIELD_W - 1) ballX++;	//o[łP}X点
					else if (barDirecX == DIREC_LEFT) ballDirecX = DIREC_NEUTRAL;
				}
				else	//(ballDirecX == DIREC_NEUTRAL)
				{
					ballDirecX = barDirecX;
				}
			}
		}
		else if (BAR_Y <= ballY)		//o[̉֍s
		{
			fieldCount = 0;
			state = ST_GAMEOVER;
		}
		ballY += ballDirecY;
		
		//ubNƂ̓蔻Ɣ
		if (BLOCK_AREA_Y <= ballY && ballY < BLOCK_AREA_Y + BLOCK_AREA_H)
		{
			uint8_t		rr = ballY - BLOCK_AREA_Y;
			
			//̃{[ʒuzɃZbgiubN`撆Ƀ{[`悷邽߁j
			if (block[rr][ballX] == 0)
			{
				block[rr][ballX] = BALL_COLOR_NUM;
				ballPainted = 1;
			}
			else
			{
				block[rr][ballX]--;
				ballDirecY = -ballDirecY;	//cAƂ˂
				ballDirecX = -ballDirecX;
				
				//NA
				if (--restCount == 0)
				{
					fieldCount = 0;
					state = ST_CLEAR;
				}
			}
		}
		
	}	//end of while(1)
	
	return 0;
}

//ʂ`
void	draw()
{
	static	uint8_t		rr, boldCount;
	
	//fL21-262C
	if (lineCount < DRAW_LINE_TOP)
	{
		//`Jn
		if (lineCount == DRAW_LINE_TOP - 1)
		{
			rr = 0;
			boldCount = 0;
		}
	}
	//ubN̋Ԃ`
	else if (lineCount < cellToLine(BLOCK_AREA_Y))
	{
		uint16_t	ballLine = cellToLine(ballY);
		
		videoOut(SCRN_COLOR);
		
		//̋ԂɃ{[Ε`
		//vCtB[h[̏c̕`^C~O킹sAif()3Ԃɕ
		if (lineCount < ballLine)
		{
			delay_loop(5 + 3);	nop();
		}
		else if (lineCount < ballLine + CELL_H)
		{
			delay_loop(0 + 4);
			bbPos[ballX] = BALL_COLOR_NUM;
		}
		else	//(ballLine + CELL_H <= lineCount)
		{
			delay_loop(2 + 4);
		}
		aryPaint((uint16_t *)bbPos, FIELD_W);
		videoOut(SCRN_COLOR);	videoOut(ColorWHITE);	//vCtB[h[̏c
		bbPos[ballX] = 0;		//2sZbgňĕ`敝𒲐
		delay_loop(1);			//
		
		videoOut(SCRN_COLOR);
	}
	//ubN`
	else if (lineCount < cellToLine(BLOCK_AREA_Y + BLOCK_AREA_H))
	{
		videoOut(SCRN_COLOR);
		delay_loop(11);		//KvȂnop()ǉŔ
		
		aryPaint((uint16_t *)block[rr], (uint8_t)BLOCK_COLUMN);
		videoOut(SCRN_COLOR);	videoOut(ColorWHITE);	delay_loop(4);	//vCtB[h[̏c
		
		videoOut(SCRN_COLOR);
		
		if (++boldCount == CELL_H)
		{
			boldCount = 0;
			rr++;
		}
	}
	//ubNƃo[̊Ԃ̋Ԃ`
	else if (lineCount < cellToLine(BAR_Y))
	{
		uint16_t	ballLine = cellToLine(ballY);
		
		videoOut(SCRN_COLOR);
		
		//̋ԂɃ{[Ε`
		//vCtB[h[̏c̕`^C~O킹sAif()3Ԃɕ
		if (lineCount < ballLine)
		{
			delay_loop(5);
		}
		else if (lineCount < ballLine + CELL_H)
		{
			bbPos[ballX] = BALL_COLOR_NUM;
		}
		else	//(ballLine + CELL_H <= lineCount)
		{
			delay_loop(2);	nop();	nop();
		}
		aryPaint((uint16_t *)bbPos, FIELD_W);
		videoOut(SCRN_COLOR);	videoOut(ColorWHITE);	//vCtB[h[̏c
		bbPos[ballX] = 0;		//2sZbgňĕ`敝𒲐
		delay_loop(1);			//
		
		videoOut(SCRN_COLOR);
	}
	//o[`
	else if (lineCount < cellToLine(BAR_Y) + CELL_H)
	{
		videoOut(SCRN_COLOR);
		delay_loop(10);	nop();	nop();	//KvȂnop()ǉŔ
		
		aryPaint((uint16_t *)bbPos, barX);	//o[̈ʒu܂ł̋󔒂`i20łokj
		videoOut(BAR_COLOR);	delay_loop(12 * BAR_W);		//o[`
		//vCtB[hE[̏c͏ȗi`̃^C~O킹̂ʓ|j
		
		videoOut(SCRN_COLOR);
	}
	else
	{
		videoOut(SCRN_COLOR);
	}
}

//vCJn̏
void	init(int8_t *barDirecX, int8_t *ballDirecX, int8_t *ballDirecY, uint8_t *restCount)
{
	uint8_t		rr, cc;
	
	barX = FIELD_W / 2;
	ballX = barX;
	ballY = BAR_Y - 1;
	*barDirecX = DIREC_NEUTRAL;
	*ballDirecX = DIREC_NEUTRAL;
	*ballDirecY = DIREC_UP;
	
	//ubN̏l
	for (rr = 0; rr < BLOCK_ROW; rr++)
		for (cc = 0; cc < BLOCK_COLUMN; cc++)
			block[rr][cc] = 2;
	*restCount = BLOCK_ROW * BLOCK_COLUMN * 2;

	bbPos[ballX] = BALL_COLOR_NUM;
}
